package com.sun.jmx.snmp;

import java.util.Enumeration;
import java.util.Vector;

public class SnmpVarBindList extends Vector<SnmpVarBind>
{
    private static final long serialVersionUID = -7203997794636430321L;
    public String identity;
    Timestamp timestamp;
    
    public SnmpVarBindList() {
        super(5, 5);
        this.identity = "VarBindList ";
    }
    
    public SnmpVarBindList(int initialCapacity) {
        super(initialCapacity);
        this.identity = "VarBindList ";
    }
    
    public SnmpVarBindList(String identity) {
        super(5, 5);
        this.identity = "VarBindList ";
        this.identity = identity;
    }
    
    public SnmpVarBindList(SnmpVarBindList list) {
        super(list.size(), 5);
        this.identity = "VarBindList ";
        list.copyInto(this.elementData);
        this.elementCount = list.size();
    }
    
    public SnmpVarBindList(Vector<SnmpVarBind> vector) {
        super(vector.size(), 5);
        this.identity = "VarBindList ";
        Enumeration<Object> elements = vector.elements();
        while (elements.hasMoreElements()) {
            this.addElement(((SnmpVarBind)elements.nextElement()).clone());
        }
    }
    
    public SnmpVarBindList(String identity, Vector<SnmpVarBind> vector) {
        this(vector);
        this.identity = identity;
    }
    
    public Timestamp getTimestamp() {
        return this.timestamp;
    }
    
    public void setTimestamp(Timestamp timestamp) {
        this.timestamp = timestamp;
    }
    
    public final synchronized SnmpVarBind getVarBindAt(int index) {
        return (SnmpVarBind)this.elementAt(index);
    }
    
    public synchronized int getVarBindCount() {
        return this.size();
    }
    
    public synchronized Enumeration<SnmpVarBind> getVarBindList() {
        return this.elements();
    }
    
    public final synchronized void setVarBindList(Vector<SnmpVarBind> vector) {
        this.setVarBindList(vector, false);
    }
    
    public final synchronized void setVarBindList(Vector<SnmpVarBind> vector, boolean b) {
        synchronized (vector) {
            int size = vector.size();
            this.setSize(size);
            vector.copyInto(this.elementData);
            if (b) {
                for (int i = 0; i < size; ++i) {
                    this.elementData[i] = ((SnmpVarBind)this.elementData[i]).clone();
                }
            }
        }
    }
    
    public synchronized void addVarBindList(SnmpVarBindList list) {
        this.ensureCapacity(list.size() + this.size());
        for (int i = 0; i < list.size(); ++i) {
            this.addElement(list.getVarBindAt(i));
        }
    }
    
    public synchronized boolean removeVarBindList(SnmpVarBindList list) {
        boolean removeElement = true;
        for (int i = 0; i < list.size(); ++i) {
            removeElement = this.removeElement(list.getVarBindAt(i));
        }
        return removeElement;
    }
    
    public final synchronized void replaceVarBind(SnmpVarBind obj, int index) {
        this.setElementAt(obj, index);
    }
    
    public final synchronized void addVarBind(String[] array, String s) throws SnmpStatusException {
        for (int i = 0; i < array.length; ++i) {
            SnmpVarBind obj = new SnmpVarBind(array[i]);
            obj.addInstance(s);
            this.addElement(obj);
        }
    }
    
    public synchronized boolean removeVarBind(String[] array, String s) throws SnmpStatusException {
        boolean n = true;
        for (int i = 0; i < array.length; ++i) {
            SnmpVarBind o = new SnmpVarBind(array[i]);
            o.addInstance(s);
            int indexOfOid = this.indexOfOid(o);
            try {
                this.removeElementAt(indexOfOid);
            }
            catch (ArrayIndexOutOfBoundsException ex) {
                n = false;
            }
        }
        return n;
    }
    
    public synchronized void addVarBind(String[] array) throws SnmpStatusException {
        this.addVarBind(array, null);
    }
    
    public synchronized boolean removeVarBind(String[] array) throws SnmpStatusException {
        return this.removeVarBind(array, null);
    }
    
    public synchronized void addVarBind(String s) throws SnmpStatusException {
        this.addVarBind(new SnmpVarBind(s));
    }
    
    public synchronized boolean removeVarBind(String s) throws SnmpStatusException {
        int indexOfOid = this.indexOfOid(new SnmpVarBind(s));
        try {
            this.removeElementAt(indexOfOid);
            return true;
        }
        catch (ArrayIndexOutOfBoundsException ex) {
            return false;
        }
    }
    
    public synchronized void addVarBind(SnmpVarBind obj) {
        this.addElement(obj);
    }
    
    public synchronized boolean removeVarBind(SnmpVarBind obj) {
        return this.removeElement(obj);
    }
    
    public synchronized void addInstance(String s) throws SnmpStatusException {
        for (int size = this.size(), i = 0; i < size; ++i) {
            ((SnmpVarBind)this.elementData[i]).addInstance(s);
        }
    }
    
    public final synchronized void concat(Vector<SnmpVarBind> vector) {
        this.ensureCapacity(this.size() + vector.size());
        Enumeration<Object> elements = vector.elements();
        while (elements.hasMoreElements()) {
            this.addElement(elements.nextElement());
        }
    }
    
    public synchronized boolean checkForValidValues() {
        int size = this.size();
        int i = 0;
        while (i < size) {
            if (!((SnmpVarBind)this.elementData[i]).isValidValue()) {
                return false;
            }
            ++i;
        }
        return true;
    }
    
    public synchronized boolean checkForUnspecifiedValue() {
        int size = this.size();
        int i = 0;
        while (i < size) {
            if (((SnmpVarBind)this.elementData[i]).isUnspecifiedValue()) {
                return true;
            }
            ++i;
        }
        return false;
    }
    
    public synchronized SnmpVarBindList splitAt(int i) {
        __Null _Null = null;
        if (i > this.elementCount) {
            return _Null;
        }
        SnmpVarBindList list = new SnmpVarBindList();
        int size;
        for (size = this.size(), ; i < size; ++i) {
            list.addElement((SnmpVarBind)this.elementData[i]);
        }
        this.elementCount = i;
        this.trimToSize();
        return list;
    }
    
    public synchronized int indexOfOid(SnmpVarBind snmpVarBind, int i, int n) {
        SnmpOid oid = snmpVarBind.getOid();
        while (i < n) {
            if (oid.equals(((SnmpVarBind)this.elementData[i]).getOid())) {
                return i;
            }
            ++i;
        }
        return -1;
    }
    
    public synchronized int indexOfOid(SnmpVarBind snmpVarBind) {
        return this.indexOfOid(snmpVarBind, 0, this.size());
    }
    
    public synchronized int indexOfOid(SnmpOid snmpOid) {
        int size = this.size();
        int i = 0;
        while (i < size) {
            if (snmpOid.equals(((SnmpVarBind)this.elementData[i]).getOid())) {
                return i;
            }
            ++i;
        }
        return -1;
    }
    
    public synchronized SnmpVarBindList cloneWithValue() {
        SnmpVarBindList list = new SnmpVarBindList();
        list.setTimestamp(this.getTimestamp());
        list.ensureCapacity(this.size());
        for (int i = 0; i < this.size(); ++i) {
            list.addElement(((SnmpVarBind)this.elementData[i]).clone());
        }
        return list;
    }
    
    public synchronized SnmpVarBindList cloneWithoutValue() {
        SnmpVarBindList list = new SnmpVarBindList();
        int size = this.size();
        list.ensureCapacity(size);
        for (int i = 0; i < size; ++i) {
            list.addElement((SnmpVarBind)((SnmpVarBind)this.elementData[i]).cloneWithoutValue());
        }
        return list;
    }
    
    @Override
    public synchronized SnmpVarBindList clone() {
        return this.cloneWithValue();
    }
    
    public synchronized Vector<SnmpVarBind> toVector(boolean b) {
        int elementCount = this.elementCount;
        if (!b) {
            return new Vector(this);
        }
        Vector<SnmpVarBind> vector = new Vector(elementCount, 5);
        for (int i = 0; i < elementCount; ++i) {
            vector.addElement(((SnmpVarBind)this.elementData[i]).clone());
        }
        return vector;
    }
    
    public String oidListToString() {
        StringBuilder sb = new StringBuilder(300);
        for (int i = 0; i < this.elementCount; ++i) {
            sb.append(((SnmpVarBind)this.elementData[i]).getOid().toString()).append("\n");
        }
        return sb.toString();
    }
    
    public synchronized String varBindListToString() {
        StringBuilder sb = new StringBuilder(300);
        for (int i = 0; i < this.elementCount; ++i) {
            sb.append(this.elementData[i].toString()).append("\n");
        }
        return sb.toString();
    }
    
    @Override
    protected void finalize() {
        this.removeAllElements();
    }
}
